<?

/*

 	Webmedia Explorer 5.0 - Multimedia Management System
 	Copyright (C) 2007 Marc Salmurri (marc.salmurri@gmail.com)

 	This program is free software; you can redistribute it and/or modify
 	it under the terms of the GNU General Public License as published by
 	the Free Software Foundation; either version 2 of the License, or (at
 	your option) any later version.

 	This program is distributed in the hope that it will be useful, but
 	WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 	General Public License for more details.

 	You should have received a copy of the GNU General Public License
 	along with this program; if not, write to the Free Software
 	Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.

*/

	function _create_thumb ( $path, $image, $max = 600, $level = 3 )
	{
		global $thumb_quality;

		$md5 = md5 ( $path.$image.$max );

		$dir = $GLOBALS["path_thumbs"];
		
		if ( !is_dir ( $dir ) )
		{
			set_dir ( $dir );
		}
		
		for ( $i = 0; $i < $level; $i++ )
		{
			$dir .= $md5[$i]."/";

			if ( !is_dir ( $dir ) )
			{
				set_dir ( $dir );
			}
		}
		
		$cache_file 	= $dir.$md5.".jpg";
		
		$url_file 		= $dir.$md5.".jpg";
		
		$data 			= getimagesize ( $cache_file );

		$file_path 		= $GLOBALS["home"].$path."/".$image;

		$timestamp 		= @filemtime ( $cache_file );

		$filestamp 		= @filemtime ( $file_path );

		$diff 			= ( $filestamp - $timestamp );

		if ( !isset ( $_GET["refresh"] ) && file_exists ( $cache_file ) && $diff < 0 )
		{
			return array ( "md5" => $md5, "filename" => $url_file, "cache_file" => $cache_file, "width" => $data[0], "height" => $data[1] );
		}

		$extension = substr ( $image, strrpos ( $image, '.' ) + 1 );

		switch ( strtolower ( $extension ) )
		{
			case "jpg":
			case "jpeg":
			{
				$src_img = imagecreatefromjpeg ( $file_path );

				break;
			}
			case "gif":
			{
				$src_img = imagecreatefromgif ( $file_path );

				break;
			}
			case "png":
			{
				$src_img = imagecreatefrompng ( $file_path );

				break;
			}			
		}

		$src_h = imagesy ( $src_img );
		$src_w = imagesx ( $src_img );

		$new_w = $src_w;
		$new_h = $src_h;

		if ( $src_h > $max || $src_w > $max )
		{
			$r = $src_h / $src_w;

			$new_h = ($src_h > $src_w) ? $max : $max * $r;

			$new_w = $new_h / $r;
		}
		
		$dst_img = ImageCreateTrueColor ( $new_w, $new_h );

		ImageCopyResampled ( $dst_img, $src_img, 0, 0, 0, 0, $new_w, $new_h, ImageSX ( $src_img ), ImageSY ( $src_img ) );

		if ( $thumb_quality >= 0 ) ImageJpeg ( $dst_img, $cache_file, $thumb_quality );

		else ImageJpeg ( $dst_img, $cache_file );
		
		chmod ( $cache_file, 0775 );

		return array ( "md5" => $md5, "filename" => $url_file, "cache_file" => $cache_file, "width" => $new_w, "height" => $new_h );
	}

?>